;
;        EMULATOR V3.0 : TRANSFERT DE TOUS LES FICHIERS
;                        (ASCII ,DATA , COM )
;        Serge QUERNE
;
;        MAGIC SOFTWARE CRACK BAND 1986
;
;
;        TRANSFERT AMSTRAD ==> I.M.S 5000
;
	ORG	#A000
;
	LD	HL,TABLE	 INITIALISATION TABLE
	LD	DE,TABLE+1	 A 0 POUR USAGE INTENSIF
	XOR	A
	LD	(HL),A
	LD	BC,100
	LDIR	
	CALL	CATALOG
PR1	LD	HL,#1	; ADR 1ER NOM
	LD	A,64	 NB DE FICHIER MAXI
	PUSH	AF
	PUSH	HL
	LD	DE,#0B05	 POSITION CURSEUR
LOOP	LD	H,D
	LD	L,E
	CALL	#BB75
	CALL	INVERSE
	POP	HL
	PUSH	HL
	CALL	AFNOM
	CALL	#BB06	 ATTEND UNE TOUCHE
	CP	13	 EST CE RETURN
	JR	Z,SELECT
	LD	H,D
	LD	L,E
	CALL	#BB75
	CALL	NORMAL
	POP	HL
	PUSH	HL
	CALL	AFNOM
S1	POP	HL
	POP	AF	 RECUPERE NB FICHIER
	DEC	A	 MOINS 1
	JR	Z,PR1	 FINI ?
	PUSH	AF
	LD	BC,32
	ADD	HL,BC
	LD	A,(HL)
	PUSH	HL
	CP	#E5
	JR	Z,S1
	INC	E
	JP	LOOP
;
INVERSE	XOR	A
	CALL	#BB90
	LD	A,1
N1	CALL	#BB96
	RET	
NORMAL	LD	A,1
	CALL	#BB90
	XOR	A
	JR	N1
AFNOM	LD	B,11	; TRANSFERT DU NOM
	PUSH	DE	 DANS EMULATOR S2
	LD	DE,#A4FA
AFFGEN	LD	A,(HL)
	AND	#7F
	LD	(DE),A
	CALL	#BB5A
	INC	HL
	INC	DE
	DJNZ	AFFGEN
	POP	DE
	RET	
;
SELECT	LD	A,2	; REINIT ECRAN
	CALL	#BC0E
	CALL	NORMAL
	LD	HL,#1205
	CALL	#BB75
	LD	HL,MESS8
	CALL	AFFICH
	CALL	INVERSE
	POP	HL	 RECUPERE ADR NOM
	POP	AF	 ON FAIT LE MENAGE
	PUSH	HL
	CALL	AFNOM
	CALL	NORMAL
	POP	HL
	LD	DE,TABLE	 TABLE LECTURE
	LD	BC,14
TR2	ADD	HL,BC	; POINTE SUR DESCRIPTEUR
	PUSH	HL
	LD	A,(HL)
	INC	HL
	CP	#80	 PLUS DE 16 K ?
	LD	BC,16	 AU MOINS 16 BLOCKS
	LDIR		 TRANSFERT DS TABLE
	POP	HL
	JR	NZ,TRFINI
	LD	BC,32
	JR	TR2
TRFINI	LD	DE,TABLE	; TABLE DE LECTURE
	LD	HL,#100	 BUFFER DE CHARGEMENT
	LD	BC,0	 INIT COMPTEUR TAILLE
CONTLOD	LD	A,(DE)
	OR	A	 FINI ?
	JR	Z,FIN1
	INC	B
	PUSH	BC	 SAUVE COMPTEUR
	PUSH	DE	 SAUVE TABLE
	PUSH	HL
	CALL	CALC	 C=SECTEUR ET D=PISTE
	POP	HL
	LD	B,2
	CALL	LOAD	 ET ON LIT LE FICHIER
	POP	DE
	POP	BC
	INC	DE
	JR	CONTLOD
FIN1	PUSH	BC
	LD	HL,MESS9
	CALL	AFFICH
	CALL	#BB06
	POP	BC	 RECUPERE NB BLOCK
	LD	C,0	 POUR CALCUL DE 
	LD	HL,0	 LA LONGUEUR DS HL
INFB2	LD	DE,#400
	ADD	HL,DE
	DJNZ	INFB2
	LD	A,3
	LD	(#A8A4),A	 1024 OCTETS SECT IMS
;
;        HL CONTIENT LA LONGUEUR PHYSIQUE DU FICHIER
;                       TRANSFERT PHYSIQUE 2
	CALL	#A400
;
;
	CALL	#BB06
	CP	13
	JP	Z,#A000
	LD	HL,#40	 POUR RETOUR AU BASIC
	LD	DE,#41	 SANS EFFUSION DE SANG
	XOR	A
	LD	(HL),A
	LD	BC,#1000
	LDIR	
	SCF	
	RET	
;
CALC	LD	D,0	; PISTE 0
	LD	B,A
	LD	A,(SECDEB)
CALC1	PUSH	BC
	LD	B,2
CALC2	INC	A
	PUSH	HL
	LD	HL,SECFIN
	CP	(HL)
	POP	HL
	JR	NZ,CALC3
	INC	D
	LD	A,(SECDEB)
CALC3	DJNZ	CALC2
	POP	BC
	DJNZ	CALC1
	LD	C,A
	RET	
;
CATALOG	LD	A,2
	CALL	#BC0E	 MODE GRAPHIQUE 2 : 80 COLONNES
	XOR	A
	LD	BC,0
	CALL	#BC32	 ENCRE 0 A 0 (NOIR)
	LD	A,1
	LD	BC,#1A1A
	CALL	#BC32	 ENCRE 1 A COULEUR 26
	LD	BC,0
	CALL	#BC38	 BORD NOIR/NOIR
	LD	HL,MESS
	CALL	AFFICH
;
	LD	HL,#40	 BUFFER POUR CHARGER DIRECTORY
	PUSH	HL
	LD	B,4	 LIRE 4 SECTEURS
	LD	D,0	 PISTE 0
	LD	A,(SECDEB)
	LD	C,A	 1ER SECTEUR
	CALL	LOAD
;
	LD	HL,MESS2
	CALL	AFFICH
	LD	HL,#0105	 POSITIONNE CURSEUR 01,04
	CALL	#BB75
	POP	HL
	LD	A,62	 NB D'ENTREES MAXI 
	PUSH	AF
CONT	CALL	VERIF
	LD	A,"#"
	CALL	#BB5A	 AFFICHE #
	LD	A,(HL)
	CALL	AFFHEX	 SUIVI DU USER EN HEXA
	PUSH	HL
	LD	HL,MESS3
	CALL	AFFICH	 AFFICHE UNE SERIE DE BLANCS
	POP	HL
	PUSH	HL
	LD	B,11	 ET AFFICHE LE NOM
NOM	INC	HL
	LD	A,(HL)
	AND	#7F	 CARACTERE NORMAUX
	CALL	#BB5A
	DJNZ	NOM
	CALL	AFFTYP	 ET AUSSI LE TYPE
	POP	HL	 RECUPERE ADRESSE
CONT1	POP	AF	; RECUPERE COMPTEUR FICHIER
	DEC	A
	RET	Z	 FINI !!
	PUSH	AF
	LD	BC,32	 AU PROCHAIN SVP
	ADD	HL,BC
	LD	A,(HL)
	CP	#E5	 EST CE VIDE OU EFFACE ?
	JR	Z,CONT1
	LD	A,13	 ENVOI DES CODES 13 ET 10
	CALL	#BB5A	 POUR RETOUR A LA LIGNE
	LD	A,10
	CALL	#BB5A
	JP	CONT
;
VERIF	PUSH	HL	; EST CE UNE STRUCTURE CHAINEE
	LD	BC,15
	ADD	HL,BC
	LD	A,(HL)
	POP	HL
	CP	#80
	LD	A," "
	JR	NZ,SUIT
	LD	A,"c"
SUIT	CALL	#BB5A
	LD	A,":"
	CALL	#BB5A
	RET	
;
AFFICH	LD	A,(HL)
	OR	A
	RET	Z
	CALL	#BB5A	 AFFICHE CARACTERE
	INC	HL
	JR	AFFICH
;
AFFHEX	PUSH	AF
	SRA	A
	SRA	A
	SRA	A
	SRA	A
	CALL	CONV1
	POP	AF
CONV1	AND	#0F
	OR	#30
	CP	#3A
	JR	C,CONV2
	ADC	A,#7
CONV2	CALL	#BB5A	; AFFICHE CARACTERE
	RET	
;
AFFTYP	DEC	HL
	LD	A,(HL)
	SLA	A	 BIT 7 ETAIT 1 OU 0 ?
	PUSH	HL
	LD	HL,MESS4	 VISIBLE
	JR	NC,TYP1
	LD	HL,MESS5	 INVISIBLE
TYP1	CALL	AFFICH
	POP	HL
	DEC	HL
	LD	A,(HL)
	SLA	A
	LD	HL,MESS7	 READ WRITE
	JR	NC,TYP2
	LD	HL,MESS6	 READ ONLY
TYP2	CALL	AFFICH
	RET	
;
LOAD	PUSH	BC	; SAUVE COMPTEUR ET SECTEUR
	PUSH	DE	 SAUVE PISTE
	PUSH	HL	 SAUVE BUFFER
	CALL	LIRE
	POP	HL
	POP	DE
LOAD1	INC	H
	INC	H
	POP	BC
	INC	C
	LD	A,(SECFIN)
	CP	C
	JR	NZ,LOAD2
	LD	A,(SECDEB)
	LD	C,A
	INC	D
LOAD2	DJNZ	LOAD
	RET	
;
LIRE	LD	E,0	; NO DU DRIVE
	RST	#18	 INTERRUPTION #18
	DW	LECT	 (LECT)=ADR ROM + NO ROM
	RET	
LECT	DW	#C666	; LIRE SECTEUR ADR ROM
	DB	7	 ROM DISK
SECDEB	DB	#41
SECFIN	DB	#4A
MESS	DB	31,20,1
	DM	STRUCTURE DIRECTORY AMST
	DM	RAD
	DB	#00
MESS2	DB	31,1,3
	DM	USER        NO
	DM	M          SPECIFICATIONS
	DB	#00
MESS3	DB	32,32,32,32,32
	DB	#00
MESS4	DB	32,32
	DM	VISIBLE
	DB	32,32,00
MESS5	DB	32,32
	DM	INVISIBLE
	DB	00
MESS6	DB	32,32
	DM	READ ONLY
	DB	32,0
MESS7	DB	32,32
	DM	READ WRITE
	DB	0
MESS8	DM	TRANSFERT DU FICHIER :
	DB	00
MESS9	DB	31,16,10
	DM	APPUYEZ SUR UNE TOUCH
	DM	E POUR LE TRANSFERT
	DB	00
MESS10	DB	31,30,13
	DM	FINI !!
	DB	00
TABLE	DS	100
